<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <title>Pillar</title>

    <link rel="stylesheet" href="/en/latestcss/core.css">
    <link rel="stylesheet" href="/en/latestcss/getstarted.css">
    <link rel="shortcut icon" href="/en/latestcss/images/saltStack_favIcon_32x32.png">

</head>
<body>

<nav id="globalNavbar" class="navbar navbar-default navbar-inverse navbar-fixed-top" role="navigation">
    <!-- Brand and toggle get grouped for better mobile display -->
    <div class="container">
        <div class="navbar-header">
            <button type="button" class="navbar-toggle" data-toggle="collapse" data-target="#navbarCollapse">
                <span class="sr-only">Toggle navigation</span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
            </button>
            <a href="http://saltstack.com/" target="_blank"><img src="/en/latestcss/images/saltstack.svg" height="40px" width="170px" class="nolightbox"></a>
        </div>
        <!-- Collect the nav links, forms, and other content for toggling -->
        <div class="collapse navbar-collapse" id="navbarCollapse">
            <ul class="nav navbar-nav">
                <li><a href="/en/latest">Documentation</a></li>
                <li><a href="/en/getstarted/">Tutorials</a></li>
                <li><a href="/en/latestcontents.html">Reference Guide</a></li>
                <li><a href="https://repo.saltstack.com">Downloads</a></li>
                <li><a href="/en/latesttopics/development/">Develop</a></li>
            </ul>
        </div>
    </div>
</nav>

<div class="jumbotron">

    <div class="row row-centered">
        <div class="col-md-9 col-centered">
            <h1>SaltStack Configuration Management</h1>

            <h3>Get Started Tutorial</h3>

        </div>
    </div>
    <!--<div class="gs-top-nav">
        <a href="/en/getstarted/getstarted/index.html">Back to Get Started <i class="glyphicon glyphicon-arrow-left"></i></a><br>
        <a href="/en/getstarted">Back to Documentation <i class="glyphicon glyphicon-arrow-left"></i></a>
    </div>-->
</div>







<div class="container">
    <div class="row">
        <div class="col-md-12">
            <ol class="progtrckr" data-progtrckr-steps="7">
                
                
                
                <li class="progtrckr-done">
                    
                    <a href="/en/getstarted/config/index.html">Introduction</a>
                </li>
                
                
                
                
                <li class="progtrckr-done">
                    
                    <a href="/en/getstarted/config/functions.html">Functions</a>
                </li>
                
                
                
                <li class="progtrckr-done">Pillar</li>
                
                
                
                
                
                
                
                
                
                
                
                
                
                <li class="progtrckr-todo">
                    
                    <a href="/en/getstarted/config/include.html">Includes</a>
                </li>
                
                
                
                
                <li class="progtrckr-todo">
                    
                    <a href="/en/getstarted/config/requisites.html">Ordering & Requisites</a>
                </li>
                
                
                
                
                <li class="progtrckr-todo">
                    
                    <a href="/en/getstarted/config/jinja.html">Jinja</a>
                </li>
                
                
                
                
                <li class="progtrckr-todo">
                    
                    <a href="/en/getstarted/config/files.html">Manage Files</a>
                </li>
                
                
            </ol>
        </div>
    </div>

    <div class="row">
        <div class="col-md-1"></div>
        <div class="col-md-10">

            

            <h1>Pillar</h1>

            <div class="section gs-overview">

                
                <p class="p gs-overview-sub"><span class="ph">You'll learn how to:</span></p>

                <ul class="ul">
                    
                    <li class="progtrckr-done">Create the pillar Top.sls file</li>
                    
                    <li class="progtrckr-done">Define and assign some pillar keys to your systems</li>
                    
                </ul>
                

                
                <p class="p gs-overview-sub gs-time"><span class="ph">
                              Estimated time: 15 minutes</span>&nbsp;<i
                        class="glyphicon glyphicon-time"></i>
                </p>
                

                
                <p class="p gs-overview-sub gs-difficulty-1"><span class="ph">Difficulty</span>:&nbsp;
                    
                    
                    <i class="glyphicon glyphicon-cog"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                </p>
                
            </div>
            

            <div class="section sidebar">
<h4 id="salt-pillar-explained">Salt Pillar Explained</h4>
<p>Salt pillar is a system that lets you define secure data that are ‘assigned’ to one or more minions using targets. Salt pillar data stores values such as ports, file paths, configuration parameters, and passwords.</p>
<h4 id="section">{{ }} ?</h4>
<p>Values within the curly braces are <a href="http://jinja.pocoo.org/">Jinja2</a> statements and expressions. We’ll discuss Jinja2 later in this guide.</p>
<h4 id="pillar.get">pillar.get</h4>
<p><a href="https://docs.saltstack.com/en/2015.5/topics/pillar/index.html#pillar-get-function">pillar.get</a> can also be used to retrieve pillar data in Salt states. This function is a bit more complicated than accessing the pillar dictionary, but it has some enhancements that make it a better choice after you get the hang of using pillar.</p>
</div>
<p>Salt pillar is an essential component to make Salt states re-usable, so we are going to take a quick detour from writing Salt states to set it up.</p>
<h2 id="salt-pillar-top-file">Salt Pillar Top File</h2>
<p>Salt pillar uses a Top file to match Salt pillar data to Salt minions. This Top file is very much like the Top file that is used to match Salt states to Salt minions.</p>
<p>Like Salt state functions, Salt pillar is best learned by example. Create the <code>salt-vagrant-demo-master/saltstack/pillar</code> directory, and then create a new file called <code>top.sls</code>. Add the following:</p>
<pre class="language-yaml"><code class="language-yaml"><span class="fu">base:</span>
  <span class="fu">&#39;*&#39;:</span>
    <span class="kw">-</span> default</code></pre>
<p>Next, create a file named <code>default.sls</code> in the same <code>pillar</code> directory and add the following:</p>
<pre class="language-yaml"><code class="language-yaml"><span class="fu">editor:</span> vim</code></pre>
<p>When Salt pillar data is refreshed, each Salt minion is matched against the targets listed in the <code>top.sls</code> file. When a Salt minion matches a target, it receives all of the Salt pillar SLS files defined in the list underneath that target. Simple, right?</p>
<p>Since our <code>*</code> glob matches all Salt minions, each Salt minion receives <code>default</code> with a pillar key of <code>editor</code> with a value of <code>vim</code>.</p>
<h2 id="refresh-salt-pillar">Refresh Salt Pillar</h2>
<p>We are going to use the Salt pillar value we just configured, so let’s first refresh Salt pillar data on all minions:</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">salt</span> <span class="st">&#39;*&#39;</span> saltutil.refresh_pillar</code></pre>
<h2 id="salt-pillar-in-salt-states">Salt Pillar in Salt States</h2>
<p>Salt pillar keys are available in a dictionary in Salt states, so you could now update the example state from the previous section to use this Salt pillar key:</p>
<pre class="language-yaml"><code class="language-yaml"><span class="fu">vim installed:</span>
  <span class="fu">pkg.installed:</span>
    <span class="kw">-</span> <span class="fu">name:</span> <span class="kw">{</span>{ pillar[&#39;editor&#39;] <span class="kw">}</span>}</code></pre>
<p>Salt pillar data is secure, and you can use it to keep portions of your Salt state secret. For example, you could add the following <code>key:value</code> pairs to Salt pillar:</p>
<pre class="language-yaml"><code class="language-yaml"><span class="fu">ftpusername:</span> me
<span class="fu">ftppassword:</span> oxfm4@8t5gglu^h^&amp;</code></pre>
<p>And then reference them in a Salt state:</p>
<pre class="language-yaml"><code class="language-yaml"><span class="fu">sync directory using lftp:</span>
  <span class="fu">cmd.run:</span>
    <span class="kw">-</span> <span class="fu">name:</span> lftp -c &quot;open -u {{ pillar[&#39;ftpusername&#39;] }},{{ pillar[&#39;ftppassword&#39;] }}
           <span class="kw">-</span><span class="fu">p 22 sftp:</span>//example.com;mirror -c -R /local /remote&quot;</code></pre>
<h2 id="salt-pillar-on-the-command-line">Salt Pillar on the command line</h2>
<p>For testing or for ad hoc management, you can pass Salt pillar values directly on the command line. These values override any value that might be set in a Salt pillar file.</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">salt</span> <span class="st">&#39;*&#39;</span> state.apply ftpsync pillar=<span class="st">&#39;{&quot;ftpusername&quot;: &quot;test&quot;, &quot;ftppassword&quot;: &quot;0ydyfww3giq8&quot;}&#39;</span></code></pre>
<h2 id="salt-pillar-can-customize-nearly-any-part-of-a-salt-state">Salt Pillar can customize nearly any part of a Salt state</h2>
<p>Hopefully it is becoming clear that you can use the Salt pillar targeting system to customize nearly any value in your Salt state files.</p>
<p>For example, you could create <code>prodftp.sls</code> and <code>stageftp.sls</code> Salt pillar files, insert different credentials into each, and then target different systems with each file. The same <code>examples.sls</code> Salt state file is used for each system, but different user names and passwords would be used based on the Salt pillar file received.</p>


            <br>
            
            <a href="/en/getstarted/config/functions.html">
                <button type="button" class="btn btn-secondary"><span
                        class="glyphicon glyphicon-chevron-left"></span> Previous
                </button>
            </a>
            

            
            <a href="/en/getstarted/config/include.html">
                <button type="button" class="btn btn-primary btn-right">
                    Next <span class="glyphicon glyphicon-chevron-right"></span></button>
            </a>
            

        </div>
        <div class="col-md-1"></div>
    </div>
    <div class="footer">
    <p>© 2020 SaltStack | <a href="http://saltstack.com/privacy-policy" target="_blank">Privacy Policy</a></p>
</div>
</div>

<script type="text/javascript" src="/en/latestjs/core-min.js"></script>



<!--analytics-->
<script type="text/javascript" language="javascript">llactid=23943</script>
<script type="text/javascript" language="javascript" src="https://trackalyzer.com/trackalyze_secure.js"></script>

<script>
          var _gaq = _gaq || [];
          var pluginUrl = '//www.google-analytics.com/plugins/ga/inpage_linkid.js';
          _gaq.push(['_require', 'inpage_linkid', pluginUrl]);
          _gaq.push(['_setAccount', 'UA-26984928-1']);
          _gaq.push(['_setDomainName', 'saltstack.com']);
          _gaq.push(['_trackPageview']);

          (function() {
              var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
              ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
              var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
          })();

</script>

</body>
</html>